//
//  ViewController.m
//  加入购物车
//
//  Created by Elephant on 16/9/5.
//  Copyright © 2016年 RDX. All rights reserved.
//

#import "ViewController.h"
#import "AX_AddShopCartView.h"

#define MAINWIDTH [UIScreen mainScreen].bounds.size.width
#define MAINHEIGHT [UIScreen mainScreen].bounds.size.height

@interface ViewController () <AX_AddShopCartViewDelegate>

@property (strong, nonatomic) AX_AddShopCartView *ascView;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    UIButton *button = [[UIButton alloc]initWithFrame:CGRectMake(100, 100, 100, 100)];
    button.backgroundColor = [UIColor brownColor];
    [button setTitle:@"购物车" forState:UIControlStateNormal];
    [button setTitleColor:[UIColor redColor] forState:UIControlStateNormal];
    [button addTarget:self action:@selector(buttonClick) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:button];
    
    UIButton *specBut = [[UIButton alloc]initWithFrame:CGRectMake(100, CGRectGetMaxY(button.frame) + 20, 100, 100)];
    specBut.backgroundColor = [UIColor redColor];
    [specBut setTitle:@"开启规格" forState:UIControlStateNormal];
    [specBut setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [specBut addTarget:self action:@selector(specButClick:) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:specBut];
    
    self.ascView.delegate = self;
    /** 设置购物车视图数据 */
    self.ascView.isGuiGe = NO;
    self.ascView.shopSpec = @"上衣 蓝色 ML";
    [self.ascView shopCartIcon:nil price:99.99 inventory:123 shopNum:10];
}

#pragma mark - AX_AddShopCartViewDelegate
- (void)submitShopCart:(AX_SpecView *)specView current:(NSInteger)current
{
    /** 提交数据 */
    NSLog(@"数量 = %ld", current);
}
#pragma mark -

- (void)specButClick:(UIButton *)specBut
{
    /** 弹出加入购物车视图 */
    [self.ascView popModalView];
    
    if (self.ascView.isGuiGe) {
        [specBut setTitle:@"开启规格" forState:UIControlStateNormal];
        self.ascView.isGuiGe = NO;
    }else {
        [specBut setTitle:@"关闭规格" forState:UIControlStateNormal];
        self.ascView.isGuiGe = YES;
    }
}

- (void)buttonClick
{
    /** 弹出加入购物车视图 */
    [self.ascView popModalView];
}


- (AX_AddShopCartView *)ascView
{
    if (!_ascView) {
        _ascView = [AX_AddShopCartView viewWithNibSize:CGSizeMake(320, 568 - 64)];
        [self.view addSubview:_ascView];
    }
    return _ascView;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
