//
//  AX_AddShopCartView.h
//  加入购物车
//
//  Created by Elephant on 16/9/5.
//  Copyright © 2016年 RDX. All rights reserved.
//

#import <UIKit/UIKit.h>

#import "AX_AddSubtractTextField.h"
#import "AX_SpecView.h"

@protocol AX_AddShopCartViewDelegate <NSObject>
/** 加入购物车代理 
 * specView : 规格视图 - 可以拿到自定义所选规格数据
 * current  : 当前数量 - 拿到所选数量
 **/
- (void)submitShopCart:(AX_SpecView *)specView current:(NSInteger)current;

@end

@interface AX_AddShopCartView : UIView

/** 自定义规格视图 */
@property (strong, nonatomic) AX_SpecView *specView;
/** 数量选择控件 */
@property (strong, nonatomic) AX_AddSubtractTextField *asTF;

@property (assign, nonatomic) id<AX_AddShopCartViewDelegate> delegate;

/** 是否有规格，必须传值。 0 ：NO   1 ：YES  */
@property (assign, nonatomic) NSInteger isGuiGe;
/** 商品规格 */
@property (copy, nonatomic) NSString *shopSpec;

/** 初始化视图 
 * size : 视图宽高
 **/
+ (instancetype)viewWithNibSize:(CGSize)size;
/** 弹出视图 */
- (void)popModalView;
/** 隐藏视图 */
- (void)dismissModalView;

/*** 设置数据
 * iconUrl   : 商品图片URL
 * price     : 商品价格
 * inventory : 商品库存
 * shopNum   : 商品数量
 **/
- (void)shopCartIcon:(NSString *)iconUrl price:(CGFloat)price inventory:(NSInteger)inventory shopNum:(NSInteger)shopNum;

@end
