//
//  AX_AddSubtractTextField.m
//  加入购物车
//
//  Created by Elephant on 16/9/6.
//  Copyright © 2016年 RDX. All rights reserved.
//

#import "AX_AddSubtractTextField.h"

@interface AX_AddSubtractTextField ()
@property (strong, nonatomic) UITextField *textField; // 宽高比 3.75 ：1
@property (strong, nonatomic) UIButton *jianBut;
@property (strong, nonatomic) UIButton *jiaBut;

@end

@implementation AX_AddSubtractTextField

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        self.backgroundColor = [UIColor whiteColor];
        self.clipsToBounds = YES;
        self.layer.cornerRadius = 5.0;
        self.layer.borderColor = [UIColor grayColor].CGColor;
        self.layer.borderWidth = 0.5;
        
        [self initializeView];
    }
    return self;
}

- (void)initializeView
{
    self.textField.placeholder = @"0";
    self.textField.frame = self.frame;
    [self.textField addTarget:self action:@selector(textFieldDidChange:) forControlEvents:UIControlEventEditingChanged];
    
    self.jianBut.frame = CGRectMake(0, 0, self.textField.frame.size.height, self.textField.frame.size.height);
    [self.jianBut addTarget:self action:@selector(jianClick) forControlEvents:UIControlEventTouchUpInside];
    CGFloat jianLabH = self.jianBut.frame.size.height/2;
    CGFloat jianLabY = self.jianBut.frame.size.height/2 - jianLabH/2;
    UILabel *jianLab = [[UILabel alloc]initWithFrame:CGRectMake(CGRectGetMaxX(self.jianBut.frame) - 1, jianLabY, 1, jianLabH)];
    jianLab.backgroundColor = [UIColor grayColor];
    [self.jianBut addSubview:jianLab];
    self.textField.leftView = self.jianBut;
    self.textField.leftViewMode = UITextFieldViewModeAlways;
    
    self.jiaBut.frame = CGRectMake(0, 0, self.textField.frame.size.height, self.textField.frame.size.height);
    [self.jiaBut addTarget:self action:@selector(jiaClick) forControlEvents:UIControlEventTouchUpInside];
    CGFloat jiaLabH = self.jiaBut.frame.size.height/2;
    CGFloat jiaLabY = self.jiaBut.frame.size.height/2 - jiaLabH/2;
    UILabel *jiaLab = [[UILabel alloc]initWithFrame:CGRectMake(0, jiaLabY, 1, jiaLabH)];
    jiaLab.backgroundColor = [UIColor grayColor];
    [self.jiaBut addSubview:jiaLab];
    self.textField.rightView = self.jiaBut;
    self.textField.rightViewMode = UITextFieldViewModeAlways;
    
}

/** 数量减 */
- (void)jianClick
{
    if (self.current > self.minNum) {
        self.current --;
        self.textField.text = [NSString stringWithFormat:@"%ld", self.current];
    }
    self.jiaBut.enabled = YES;
    [self.jiaBut setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
}
/** 数量加 */
- (void)jiaClick
{
    if (self.current < self.maxNum) {
        self.current ++;
        self.textField.text = [NSString stringWithFormat:@"%ld", self.current];
    }
    self.jianBut.enabled = YES;
    [self.jianBut setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
}

- (void)setCurrent:(NSInteger)current
{
    _current = current;
    if (current) {
        self.textField.text = [NSString stringWithFormat:@"%ld", current];
    }

    if (self.minNum == current) {
        self.jianBut.enabled = NO;
        [self.jianBut setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
        self.jiaBut.enabled = YES;
        [self.jiaBut setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    }
    if (self.maxNum == current) {
        self.jiaBut.enabled = NO;
        [self.jiaBut setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
        self.jianBut.enabled = YES;
        [self.jianBut setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    }
}

- (void)setMinNum:(NSInteger)minNum
{
    _minNum = minNum;
    if (minNum == self.current) {
        self.jianBut.enabled = NO;
        [self.jianBut setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
        self.jiaBut.enabled = YES;
        [self.jiaBut setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    }
}

- (void)setMaxNum:(NSInteger)maxNum
{
    _maxNum = maxNum;
    if (maxNum == self.current) {
        self.jiaBut.enabled = NO;
        [self.jiaBut setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
        self.jianBut.enabled = YES;
        [self.jianBut setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    }
}

#pragma mark - textField 监听事件

- (void) textFieldDidChange:(UITextField *) TextField{
    NSLog(@"textField = %@", TextField.text);
    self.current = [TextField.text integerValue];
    if ([TextField.text integerValue] >= self.maxNum) {
        self.current = self.maxNum;
        self.jiaBut.enabled = NO;
        [self.jiaBut setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
    }else if ([TextField.text integerValue] > self.minNum) {
        self.jianBut.enabled = YES;
        [self.jianBut setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
        self.jiaBut.enabled = YES;
        [self.jiaBut setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    }
}
#pragma mark -

#pragma mark - 懒加载
- (UITextField *)textField
{
    if (!_textField) {
        _textField = [[UITextField alloc]init];
        _textField.font = [UIFont systemFontOfSize:15.0];
        _textField.textAlignment = NSTextAlignmentCenter;
        _textField.keyboardType = UIKeyboardTypeNumberPad;
        [self addSubview:_textField];
    }
    return _textField;
}

- (UIButton *)jianBut
{
    if (!_jianBut) {
        _jianBut = [[UIButton alloc]init];
        [_jianBut setTitle:@"－" forState:UIControlStateNormal];
        [_jianBut setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
        [_jianBut setTitleColor:[UIColor grayColor] forState:UIControlStateHighlighted];
    }
    return _jianBut;
}

- (UIButton *)jiaBut
{
    if (!_jiaBut) {
        _jiaBut = [[UIButton alloc]init];
        [_jiaBut setTitle:@"＋" forState:UIControlStateNormal];
        [_jiaBut setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
        [_jiaBut setTitleColor:[UIColor grayColor] forState:UIControlStateHighlighted];
    }
    return _jiaBut;
}
#pragma mark -

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
